/*
 *  $Id: u_allreduce.c,v 1.4 1993/11/12 12:30:51 doss Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */


#ifndef lint
static char vcid[] = "$Id: u_allreduce.c,v 1.4 1993/11/12 12:30:51 doss Exp $";
#endif /* lint */

#include <mpi.h>
#include "coll.h"

/*@

MPI_User_allreduce - 

@*/
MPI_User_allreduce ( sendbuf, recvbuf, count, datatype, op, comm )
void             *sendbuf;
void             *recvbuf;
int               count;
MPI_Datatype      datatype;
void            (*op)();
MPI_Comm  comm;
{
  /* Check for invalid arguments */
  if ( (comm            == (MPI_Comm)0) ||
       (comm->comm_type == MPIR_INTER) ) 
    return (MPI_SUCCESS); 
  
  /* Reduce to 0, then bcast */
  MPI_User_reduce ( sendbuf, recvbuf, count, datatype, op, 0, comm );
  MPI_Bcast ( recvbuf, count, datatype, 0, comm );

  return (MPI_SUCCESS);
}
