/*
 *  $Id: u_reducea.c,v 1.4 1993/11/12 12:30:51 doss Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */


#ifndef lint
static char vcid[] = "$Id: u_reducea.c,v 1.4 1993/11/12 12:30:51 doss Exp $";
#endif /* lint */

#include <mpi.h>
#include "coll.h"

/*@

MPI_User_reducea - 

algorithm:  The way this function is done is horrible.  Everybody
reduces to node 0, the node 0 sends the result to node root.  Yuck.
This is done to meet the associativity requirement.  Change this soon.
@*/

MPI_User_reducea ( sendbuf, recvbuf, count, datatype, op, root, comm )
void             *sendbuf;
void             *recvbuf;
int               count;
MPI_Datatype      datatype;
void            (*op)();
int               root;
MPI_Comm  comm;
{
  int              size, rank;
  MPI_Group        group;
  MPI_Comm_request req;
  MPI_Status       status;

  /* Check for invalid arguments */
  if ( (comm            == (MPI_Comm)0) ||
       (root            <  0) || 
       (comm->comm_type == MPIR_INTER) ) 
    return (MPI_SUCCESS); 
  
  /* Is root within the communicator? */
  MPI_Comm_size ( comm, &size );
  if ( root >= size )
    return (MPI_SUCCESS);

  /* Reduce to node 0.  This takes care of the associativity part */
  MPI_Reduce ( sendbuf, recvbuf, count, datatype, op, 0, comm );
  if (rank == 0) {
    MPI_Isend ( recvbuf, count, datatype, root, MPIR_USER_REDUCEA_TAG, comm, &req );
    MPI_Wait ( req, &status );
  }
  if (rank == root) {
    MPI_Recv ( recvbuf, count, datatype, 0, MPIR_USER_REDUCEA_TAG, comm, &req );
    MPI_Wait ( req, &status );
  }
  
  return (MPI_SUCCESS);
}


