/*
 *  $Id: get_graphdims.c,v 1.4 1993/11/12 12:35:46 doss Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#include <mpi.h>

/*@

MPI_Get_graphdims - retrieve graph topology information associated with a 
                    communicator

@*/

int MPI_Get_graphdims ( comm, nnodes, nedges )
MPI_Comm  comm;
int              *nnodes;
int              *nedges;
{
  /* Check for valid arguments */
  if ( comm == (MPI_Comm)0 )
    return (MPI_SUCCESS);

  /* Set nnodes */
  if ( nnodes != (int *)0 )
    if ( comm->topology.type == MPI_GRAPH )
      (*nnodes) = comm->topology.tag.graph.nnodes;
    else
      (*nnodes) = MPI_UNDEFINED;

  /* Set nedges */
  if ( nedges != (int *)0 ) 
    if ( comm->topology.type == MPI_GRAPH )
      (*nedges) = comm->topology.tag.graph.nedges;
    else
      (*nedges) = MPI_UNDEFINED;

  return (MPI_SUCCESS);
}
